#ifndef _MYCHRO_APPPFORILE_H_
#define _MYCHRO_APPPFORILE_H_

#include "PrivateProf.h"
#include "common.h"

#define BOOLSETTOR(x) BOOL Set##x(BOOL bNew){return SetIfValidPointer( set->b.m.b##x, bNew );};
#define BOOLGETTOR(x) BOOL b##x(){return set->b.m.b##x;};
#define BOOLACCESSOR(x) BOOLSETTOR(x) BOOLGETTOR(x)

class AppProfile : public PrivateProfile
{
public:
	AppProfile(void);
	virtual ~AppProfile(void);
	BOOL SetAddress(SETTINGS *p);
	DWORD GetSize(void);
	BOOL Load(void);
	BOOL Save(void);

	DWORD ReadDisable1stSection( const TCHAR *section, BYTE **value );

	SETTINGS settings(void) { return *set; }
	inline BOOL SetIfValidPointer( BOOL &x, BOOL y )
	{
		if ( set ) {
			x = y;
			return TRUE;
		}
		return FALSE;
	}

	BOOLACCESSOR( Atok )
	BOOLACCESSOR( VKana )
	BOOLACCESSOR( Ctrl1 )
	BOOLACCESSOR( Bootcamp )
	BOOLACCESSOR( Vjed4 )
	BOOLACCESSOR( Unload )

	BOOL SetBools( int idx, BOOL bNew ) { return SetIfValidPointer( set->b.boolArray[idx], bNew ); }

protected:
	SETTINGS *set;
};

#undef BOOLACCESSOR
#undef BOOLGETTOR
#undef BOOLSETTOR

#endif//_MYCHRO_APPPFORILE_H_
