#include "stdafx.h"
#include "misc.h"
#include "common.h"

extern SETTINGS *shared;
static HWND hExeWnd = NULL;
static BOOL bInKana = FALSE;
static HHOOK hHookKeyboard = NULL;

LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam);

BOOL KbSetHook( HWND hWnd )
{
	hHookKeyboard = SetWindowsHookEx( WH_KEYBOARD_LL, LowLevelKeyboardProc, hInst, 0 );

	if ( hHookKeyboard ) {

		hExeWnd = hWnd;
		return TRUE;
	}

	return FALSE;
}

BOOL KbReleaseHook(void)
{
	if ( hHookKeyboard ) {

		if ( UnhookWindowsHookEx( hHookKeyboard ) ) {

			hHookKeyboard = NULL;
			return TRUE;
		}
	}
	return FALSE;
}

BOOL IsIgnoreClassName()
{
	BOOL bDeny = FALSE;
	TCHAR className[260];

	if ( shared->dwSizeClassName ) {

		GetClassName( GetForegroundWindow(), className, _countof(className) );

		if ( className[0] ) {

			TCHAR *cname = (TCHAR*)( (LPBYTE)shared + sizeof(SETTINGS) + shared->dwSizeProcessName );

			while( *cname ) {
				if ( _tcsicmp( className, cname ) == 0 ) {
					bDeny = TRUE;
					break;
				}
				cname += _tcslen( cname ) + 1;
			}
		}
	}

	return bDeny;
}

// L[{[h჌xtbN
LRESULT CALLBACK LowLevelKeyboardProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	INPUT input[2];
	BOOL bDeny = FALSE;

	if ( ( nCode == HC_ACTION ) && ( shared != NULL ) ) {

		KBDLLHOOKSTRUCT*pK = (KBDLLHOOKSTRUCT*)lParam;

		shared->bLastIsTab = ( pK->vkCode == VK_TAB ) ? TRUE : FALSE;

		if ( !( pK->flags & LLKHF_INJECTED ) ) {	// SendInputł̂Ŕr

			if ( pK->vkCode == shared->vkKana ) {	// JiL[ꂽ

				bDeny = IsIgnoreClassName();

				// Ђ炪ȃJix[h
				if ( wParam == WM_KEYDOWN ) {

					if ( !bInKana ) {	// s[gWM_KEYDOWN̘AȂ̂ňx󂯎

						bInKana = TRUE;
						if ( shared->b.m.bVKana ) {

							if ( !bDeny ) {

								FillInputKeyboard( &input[0], VK_KANA, FALSE, shared->vkKana == VK_KANA, (WORD)pK->scanCode );
								FillInputKeyboard( &input[1], VK_KANA, TRUE,  shared->vkKana == VK_KANA, (WORD)pK->scanCode );
								SendInput( 2, input, sizeof(INPUT) );
								PostMessage( hExeWnd, WM_FROMHOOK, 0, 0 );
							}
						}
					}
				}
				else {
					bInKana = FALSE;
					PostMessage( hExeWnd, WM_FROMHOOK, 0, 0 );
				}
				return ( shared->b.m.bVKana && !bDeny ) ? -1 : CallNextHookEx( hHookKeyboard, nCode, wParam, lParam );
			}
			//else if ( ( shared->b.m.bCtrl1 ) && ( ( pK->vkCode == VK_OEM_AUTO ) || ( pK->vkCode == VK_OEM_ENLW ) ) ) {
			else if ( ( shared->b.m.bCtrl1 ) && ( pK->scanCode == 0x29 ) ) {

				if ( !IsIgnoreClassName() ) {
					if ( wParam == WM_KEYDOWN ) {

						FillInputKeyboard( &input[0], VK_CONTROL, FALSE, TRUE );
						FillInputKeyboard( &input[1], '1'		, FALSE, TRUE );
						SendInput( 2, input, sizeof(INPUT) );
					}
					else {

						FillInputKeyboard( &input[0], '1'		, TRUE, TRUE );
						FillInputKeyboard( &input[1], VK_CONTROL, TRUE, TRUE );
						SendInput( 2, input, sizeof(INPUT) );
					}
					return -1;
				}
			}
		}
	}
	return CallNextHookEx( hHookKeyboard, nCode, wParam, lParam );
}
