#ifndef _NOTIFY_ICON_H_
#define _NOTIFY_ICON_H_

#include "misc.h"

#define WM_TRAYICONMESSAGE (WM_APP+1)

extern const UINT WM_TASKBARCREATED;


class NotifyIcon
{
public:
	NotifyIcon(void);
	virtual ~NotifyIcon(void);

	BOOL Init(void);
	BOOL AddIcon( HWND hWnd, TCHAR *tip, UINT idResource, UINT id = 0, UINT msg = WM_TRAYICONMESSAGE, HINSTANCE inst = hInst );
	BOOL DeleteIcon( HWND hWnd, UINT id = 0 );
	BOOL SetInfo( HWND hWnd, TCHAR *info, UINT id = 0 );
	BOOL ChangeIcon( HWND hWnd, UINT idResource, UINT id = 0, HINSTANCE inst = hInst );

protected:
	DWORD cbSize;
	size_t tipLen;
	BOOL infoSupported;
};

#endif//_NOTIFY_ICON_H_
