// dllmain.cpp : DLL AvP[ṼGg |Cg`܂B
#include "stdafx.h"
#include "common.h"
#include "ShareMem.h"

extern HMODULE hDLL;
extern SHARED_CONTEXT sharedContext;
extern SETTINGS* shared;
extern DWORD countForDisableIME, messageForCount;

BOOL IsIgnoreProcessName( TCHAR *fname )
{
	BOOL bDeny = FALSE;
	TCHAR *pname = (TCHAR*)( (LPBYTE)shared + sizeof(SETTINGS) );

	if ( shared->dwSizeProcessName ) {

		while( *pname ) {
			if ( _tcsicmp( fname, pname ) == 0 ) {
				bDeny = TRUE;
				break;
			}
			pname += _tcslen( pname ) + 1;
		}
	}

	return bDeny;
}
BOOL IsDisableFirstIMEProcessName( TCHAR *fname )
{
	BOOL bFound = FALSE;
	DISABLEFIRST *ds = (DISABLEFIRST*)( (LPBYTE)shared + sizeof(SETTINGS) + shared->dwSizeProcessName + shared->dwSizeClassName );

	if ( shared->dwSizeDisableFirst ) {
		while( ds->name[0] != 0 ) {
			if ( _tcsicmp( fname, ds->name ) == 0 ) {
				countForDisableIME = ds->count;
				messageForCount = ds->wParam;
				bFound = TRUE;
				break;
			}
			ds = (DISABLEFIRST*)( ( (BYTE*)ds ) + sizeof(DISABLEFIRST) + _tcslen(ds->name) * sizeof(TCHAR) );
		}
	}

	return bFound;
}

BOOL APIENTRY DllMain( HMODULE hModule,
					   DWORD  ul_reason_for_call,
					   LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		hDLL = hModule;
		shared = (SETTINGS*)OpenSharedMemory( &sharedContext, SHARED_MEMORY_IDENTIFIER );

		if ( shared ) {

			TCHAR path[_MAX_PATH], *fname;

			GetModuleFileName( NULL, path, _countof(path) );
			fname = _tcsrchr( path, _T('\\') );

			if ( fname ) {
				fname++;
				IsDisableFirstIMEProcessName( fname );
				if ( IsIgnoreProcessName( fname ) ) {
					shared = NULL;
					CloseSharedMemory( &sharedContext );
					return FALSE;
				}
			}
		}
		else {
			return FALSE;
		}
		break;

	case DLL_PROCESS_DETACH:
		shared = NULL;
		CloseSharedMemory( &sharedContext );
		hDLL = NULL;
		break;

	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

