#ifndef _SHAREMEM_H_
#define _SHAREMEM_H_

#include <windows.h>

#pragma pack(1)
typedef struct _SHARED_STRUCT {
	DWORD masterWnd;
	LPVOID customStruct;
} SHARED_STRUCT;
#pragma pack()

typedef struct _SHARED_CONTEXT {
	HANDLE handle;
	SHARED_STRUCT *pointer;
} SHARED_CONTEXT;

void *OpenSharedMemory( SHARED_CONTEXT *context, TCHAR *ident );
void *OccupySharedMemory( SHARED_CONTEXT *context, TCHAR *ident );
void CloseSharedMemory( SHARED_CONTEXT *context );
void *GetSharedAddress( SHARED_STRUCT *sharedPointer );

#endif//_SHAREMEM_H_
