#ifndef _DELTAEND_COMMON_H_
#define _DELTAEND_COMMON_H_

#include <windows.h>

#define WM_FROMHOOK	(WM_APP+2)

#define SHARED_MEMORY_IDENTIFIER	_T("DeltaEnd Shared Memory")
#define COMMON_MESSAGE_IDENTIFIER	_T("DeltaEnd for VJE-Delta4.0")

typedef enum _SIMPLE_OSVERSION {
	OS_UNKNOWN,
	OS_OLD,
	OS_9X,
	OS_NT4,
	OS_2000,
	OS_XP,
	OS_S2003,
	OS_VISTA,
	OS_S2008,
	OS_7,
	OS_S2008R2,
	OS_8,
	OS_S2012,
	OS_NEWER,
} SIMPLE_OSVERSION;

#pragma pack(1)
typedef struct _DISABLEFIRST
{
	DWORD wParam;
	DWORD count;
	TCHAR name[1];
} DISABLEFIRST;

typedef struct _SETTINGS
{
	union b_uni {
		struct b_st {
			BOOL bVKana;
			BOOL bAtok;
			BOOL bCtrl1;
			BOOL bBootcamp;
			BOOL bVjed4;
			BOOL bUnload;
			BOOL bDisable1st;
		} m;
		BOOL boolArray[sizeof(b_st)/sizeof(BOOL)];
	} b;
	BOOL bLastIsTab;
	HWND hwndImeLogger;
	DWORD vkKana;
	DWORD dwSizeProcessName;
	DWORD dwSizeClassName;
	DWORD dwSizeDisableFirst;
} SETTINGS;
#pragma pack()

#ifndef KEYEVENTF_SCANCODE
#define KEYEVENTF_SCANCODE    0x0008
#endif

void FillInputKeyboard( INPUT *input, WORD vK, BOOL bKeyUp, BOOL bScanCode = FALSE, WORD scanCode = 0xffff );
SIMPLE_OSVERSION GetSimpleOSVersion( void );

#endif//_DELTAEND_COMMON_H_