// DeltaEndDll.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include <stddef.h>
#include "common.h"
#include "ShareMem.h"


HMODULE hDLL = NULL;
BOOL bAfterOnOff = FALSE;
DWORD dwLastKana = IME_CMODE_NATIVE | IME_CMODE_FULLSHAPE;
SHARED_CONTEXT sharedContext = { NULL, NULL };
SETTINGS* shared = NULL;
DWORD countForDisableIME = 0, messageForCount = 0;

#pragma comment(linker, "/section:shared,rws")
#pragma data_seg("shared")
HHOOK hHookProcRet = NULL;
UINT wmDeltaEnd = 0;
#pragma data_seg()


LRESULT CALLBACK CallWndRetProc(int nCode, WPARAM wParam, LPARAM lParam);


extern "C" __declspec(dllexport) BOOL SetHook( HWND hWnd )
{
	BOOL bRet = FALSE;

	wmDeltaEnd = RegisterWindowMessage( COMMON_MESSAGE_IDENTIFIER );

	do {
		if ( hHookProcRet ) {
			if ( !UnhookWindowsHookEx( hHookProcRet ) ) break;
		}

		hHookProcRet = SetWindowsHookEx( WH_CALLWNDPROCRET, CallWndRetProc, hDLL, 0 );
		if ( hHookProcRet == NULL ) break;

		bRet = TRUE;

	} while ( FALSE );

	return bRet;
}


extern "C" __declspec(dllexport) BOOL ReleaseHook(void)
{
	BOOL bRet = TRUE;

	if ( hHookProcRet ) {

		if ( !UnhookWindowsHookEx( hHookProcRet ) ) {
			bRet = FALSE;
		}
		else {
			hHookProcRet = NULL;
		}
	}

	return bRet;
}


BOOL IsATOKUI( HWND hWnd )
{
	BOOL bRet = FALSE;
	TCHAR strCaption[256];
	size_t len;
	TCHAR *p;

	GetWindowText( hWnd, strCaption, 256 );
	len = _tcslen( strCaption );

	do {
		if ( len < 8 ) break;
		if ( _tcsncmp( strCaption, _T("ATOK"), 4 ) != 0 ) break;
		for ( p = strCaption + 4; ( _istdigit(*p) && ( *p != 0 ) ); p++ );
		if ( *p == 0 ) break;
		if ( _tcscmp( p, _T("UI") ) != 0 ) break;

		bRet = TRUE;

	} while( FALSE );

	return bRet;
}


BOOL IsMSCTFIMEUI( HWND hWnd )
{
	BOOL bRet = FALSE;
	TCHAR strCaption[256];

	GetWindowText( hWnd, strCaption, 256 );
	if ( _tcscmp( strCaption, _T("MSCTFIME UI") ) == 0 ) {
		bRet = TRUE;
	}

	return bRet;
}

BOOL IsVJEUI( HWND hWnd )
{
	BOOL bRet = FALSE;
	TCHAR strCaption[256];

	GetWindowText( hWnd, strCaption, 256 );
	if ( _tcscmp( strCaption, _T("VJE_UIM") ) == 0 ) {
		bRet = TRUE;
	}

	return bRet;
}

BOOL IsImeVjed4()
{
	BOOL bRet = FALSE;
	TCHAR strCaption[256];

	HKL hKl = GetKeyboardLayout( 0 );
	ImmGetDescription( hKl, strCaption, 256 );

	if ( _tcscmp( strCaption, _T("VJE-Delta Ver.4.0") ) == 0 ) {
		bRet = TRUE;
	}

	return bRet;
}

void SimulateTabKey()
{
	INPUT input[2];

	FillInputKeyboard( &input[0], VK_TAB, TRUE, TRUE );
	FillInputKeyboard( &input[1], VK_TAB, FALSE, TRUE );
	SendInput( 2, input, sizeof(INPUT) );
}


BOOL ProcessForATOK( WPARAM wParam, LPARAM lParam )
{
	BOOL bRet = FALSE;
	CWPRETSTRUCT* pcwp = (CWPRETSTRUCT*)lParam;

	if ( ( pcwp->message == WM_IME_NOTIFY ) && ( pcwp->wParam == 0x010e ) ) {

		if ( IsMSCTFIMEUI( pcwp->hwnd ) && ( shared->bLastIsTab ) ) {
			SimulateTabKey();
			bRet = TRUE;
		}
	}
	else if ( ( pcwp->message == WM_IME_NOTIFY ) && ( pcwp->wParam == IMN_PRIVATE ) ) {

		if ( IsATOKUI( pcwp->hwnd ) ) {

			if ( ( pcwp->lParam == 0x14 ) && ( shared->bLastIsTab ) ) {
				bAfterOnOff = TRUE;
			}
			else if ( ( pcwp->lParam == 4 ) || ( pcwp->lParam == 0x1a ) ) {

				if ( bAfterOnOff ) {
					bAfterOnOff = FALSE;
				}
				else if ( shared->bLastIsTab ) {
					SimulateTabKey();
				}
			}
			bRet = TRUE;
		}
	}
	return bRet;
}


BOOL ProcessForVJED4( WPARAM wParam, LPARAM lParam )
{
	BOOL bRet = FALSE;
	CWPRETSTRUCT* pcwp = (CWPRETSTRUCT*)lParam;
	DWORD dwConv, dwSent;

	if ( pcwp->message == WM_IME_NOTIFY ) {

		if ( IsImeVjed4() ) {

			if ( ( pcwp->wParam == IMN_SETOPENSTATUS ) || ( pcwp->wParam == IMN_OPENSTATUSWINDOW ) ) {	// IMEJȂ

				HIMC himc = ImmGetContext( pcwp->hwnd );  // IMEReLXg擾

				if( ( himc ) && ( IsVJEUI( pcwp->hwnd ) ) ) {	// VJE-Delta4.0{̎

					BOOL fNowOpen = ImmGetOpenStatus(himc);
					ImmGetConversionStatus(himc, &dwConv, &dwSent);

					if ( fNowOpen ) {

						if ( GetKeyState( VK_KANA ) & 1 ) {

							if ( !( dwConv & IME_CMODE_NATIVE ) ) {
								ImmSetConversionStatus( himc, dwLastKana, dwSent );
							}
						}
						else {
							if ( dwConv & IME_CMODE_NATIVE ) {
								ImmSetConversionStatus( himc, IME_CMODE_FULLSHAPE, dwSent );
							}
						}
					}
				}
				ImmReleaseContext( pcwp->hwnd, himc );
				bRet = TRUE;
			}
			else if ( pcwp->wParam == IMN_SETCONVERSIONMODE ) {

				HIMC himc = ImmGetContext( pcwp->hwnd );  // IMEReLXg擾
				BOOL fNowOpen = ImmGetOpenStatus(himc);

				if ( ( himc ) && ( fNowOpen ) ) {

					ImmGetConversionStatus(himc, &dwConv, &dwSent);

					if ( ( dwConv & IME_CMODE_NATIVE ) && ( dwConv & IME_CMODE_FULLSHAPE ) ) {
						dwLastKana = dwConv;
					}
				}
				ImmReleaseContext( pcwp->hwnd, himc );
				bRet = TRUE;
			}
		}
	}
	else if ( ( pcwp->message == wmDeltaEnd ) || ( pcwp->message == WM_ACTIVATE ) ) {

		if ( IsImeVjed4() ) {

			HIMC himc = ImmGetContext( pcwp->hwnd );  // IMEReLXg擾
			BOOL fNowOpen = ImmGetOpenStatus(himc);

			if ( ( himc ) && ( !fNowOpen ) ) {

				ImmGetConversionStatus(himc, &dwConv, &dwSent);

				if ( GetKeyState( VK_KANA ) & 1 ) {
					ImmSetConversionStatus( himc, dwLastKana, dwSent );
				}
				else {
					ImmSetConversionStatus( himc, IME_CMODE_FULLSHAPE, dwSent );
				}
			}
			ImmReleaseContext( pcwp->hwnd, himc );
			bRet = TRUE;
		}
	}
	return bRet;
}


void ProcessGeneral( WPARAM wParam, LPARAM lParam )
{
	BOOL bRet = FALSE;
	CWPRETSTRUCT* pcwp = (CWPRETSTRUCT*)lParam;

	if ( pcwp->message == WM_IME_NOTIFY ) {

		do {
			if ( shared->hwndImeLogger ) {
				HWND hWnd = GetForegroundWindow();
				if ( hWnd == NULL ) break;

				DWORD dwProcessId;
				GetWindowThreadProcessId( hWnd, &dwProcessId );
				if ( dwProcessId == NULL ) break;

				PostMessage( shared->hwndImeLogger, WM_FROMHOOK, dwProcessId, pcwp->wParam );
			}
		} while( FALSE );

		if ( ( shared->b.m.bDisable1st ) && ( countForDisableIME > 0 ) && ( pcwp->wParam == (WPARAM)messageForCount ) ) {
			countForDisableIME--;
			if ( countForDisableIME == 0 ) {
				HIMC himc = ImmGetContext( pcwp->hwnd );  // IMEReLXg擾
				if ( himc ) {
					ImmSetOpenStatus( himc, FALSE );
					ImmReleaseContext( pcwp->hwnd, himc );
				}
			}
		}
	}
}


// EBhEvV[W߂tbN
LRESULT CALLBACK CallWndRetProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if ( nCode == HC_ACTION) {
		do {
			if ( shared ) {
				ProcessGeneral( wParam, lParam );
				if ( shared->b.m.bAtok	&& ProcessForATOK( wParam, lParam ) )	break;
				if ( shared->b.m.bVjed4	&& ProcessForVJED4( wParam, lParam ) )	break;
			}
		} while ( FALSE );
	}
	return CallNextHookEx( hHookProcRet, nCode, wParam, lParam );
}



